%% Lab exercise on Geomagnetism and Waves

%% Step 5
% Access MATLAB workspace with all data. 

load('GEOMAG.mat');

%% Step 5.1
% (a) Plot the Dst index as a function of time.
%
% Variables:
% -----------------
%  Dst_time
%  Dst
%
% Functions:
% -----------------
% plotTimeSeries(X1, Y1)

figure(1)
plotTimeSeries()

% (b) Visually detect all moderate and intense geomagnetic storms.
% 

%% Step 5.2
% (a) Plot solar wind parameters: Bz, Vsw and Psw, along with Dst.
% 
% Variables:
% -----------------
%  Dst_time
%  Dst
%  Bz_time
%  Bz
%  Vsw_time
%  Vsw
%  Psw_time
%  Psw
%
% Functions:
% -----------------
% plotTimeSeries(X1, Y1, X2, Y2, X3, Y3, X4, Y4)

figure(2)
plotTimeSeries()

% (b) Identify the time of arrival of the interplanetary shock and the sudden storm
% commencement for the most intense storm.
%
% (c) Find and examine a second case, in which even though there is a CME impacting Earth
% no storm was observed and explain why. You can zoom in on the plot to find details of this second case.

%% Step 5.3
% (a) Plot the magnetometer data from the ENIGMA station Dionisos and 
% compare these with the Dst
% 
% Variables:
% -----------------
%  Dst_time
%  Dst
%  Bgr_time
%  Bgr
%
% Functions:
% -----------------
% plotTimeSeries(X1, Y1, X2, Y2)

figure(3)
plotTimeSeries()

%%
% (c) Select a time interval of a few hours during the main phase of the storm.
% Apply Fast Fourier Transform (fft) on the magnetic field data and plot the 
% Fourier Power calculated with respect to the frequency. 
% 
% NOTE: Beware that the maximum frequency does not exceed the Nyquist
% frequency of the time series (sampling time of Bgr is 1 sec)!
%
% Variables:
% -----------------
%  Bgr_time
%  Bgr
%
% Functions:
% -----------------
% [Freq, FftPower] = fourierSpectrum(Y_time, Y, begin_time, end_time, ...
%    low_freq, high_freq)

begin_time = datenum(2013,3,17,14,0,0);
end_time = datenum(2013,3,17,15,0,0);
low_freq = 2/1000;
high_freq = 7/1000;

[FreqPc5, FftPowerPc5] = fourierSpectrum(Bgr_time, Bgr, begin_time, end_time, ...
    low_freq, high_freq);

figure(4)
loglog(FreqPc5, FftPowerPc5); grid on;
xlim([low_freq, high_freq]);
xlabel('Freq (Hz)')
ylabel('Fourier Power (nT^2)');

%%
% (d) Calculate the average of the Fourier Power for every frequency range
% in the specific time interval selected.

% Variables:
% -----------------
%  FftPowerPc5
%
% Functions:
% -----------------
% mean(F)

% mean Fourier power in the Pc5 frequency range
avgPc5 = 0;
 
%% Step 5.4
% (a) Follow the previous step for every hour in the original timeseries.
% 
% Use the function fourierPower to compute the mean Fourier power for the
% entire time period of the data, for the Pc5 frequency range. To define the
% frequency range, use the "low_freq" and "high_freq" parameters. 
% Fourier transform will be applied to every segment of the given time series with
% size equal to "window_size" in seconds. You can set the value of that variable to
% 1 hour. Lastly, plot the mean Fourier power along with the Dst index as a 
% function of time
%
% NOTE: Make sure the "window_size" is large enough for the "freq_low"
% that you have specified!
% 
% Variables:
% -----------------
%  Bgr_time
%  Bgr
%  Dst_time
%  Dst
%
% Functions:
% -----------------
% [power_time, power] = fourierPower(Y_time, Y, begin_time, end_time, ...
%    window_size, begin_freq, end_freq);

begin_time = 0;
end_time = 0;
low_freq = 0;
high_freq = 0;
window_size = 0;

[powerPc5_time, powerPc5] = fourierPower();

figure(5)
plotTimeSeries()

